

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

    

<html lang="en-US" dir="ltr" xmlns="http://www.w3.org/1999/xhtml">
<head><script src="https://c.s-microsoft.com/mscc/statics/mscc-0.4.2.min.js"></script><script src="/_static/tfs/M165_20200226.19/_scripts/TFS/min/Gallery/Client/Common/ManageCookieDrop.js"></script><link rel="Stylesheet" href="https://c.s-microsoft.com/mscc/statics/mscc-0.4.2.min.css" /><title>
	
    Azure App Service - Visual Studio Marketplace

</title>
    <meta name="description" content="Extension&#32;for&#32;Visual&#32;Studio&#32;Code&#32;-&#32;An&#32;Azure&#32;App&#32;Service&#32;management&#32;extension&#32;for&#32;Visual&#32;Studio&#32;Code." /><meta name="keywords" content="App&#32;Service,Azure,keybindings,multi-root&#32;ready" /><meta property="og:title" content="Azure&#32;App&#32;Service&#32;-&#32;Visual&#32;Studio&#32;Marketplace" /><meta property="og:type" content="website" /><meta property="og:url" content="https://marketplace.visualstudio.com/items?itemName=ms-azuretools.vscode-azureappservice" /><meta property="og:image" content="https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.Icons.Default" /><meta property="og:description" content="Extension&#32;for&#32;Visual&#32;Studio&#32;Code&#32;-&#32;An&#32;Azure&#32;App&#32;Service&#32;management&#32;extension&#32;for&#32;Visual&#32;Studio&#32;Code." /><meta property="twitter:card" content="summary" /><meta property="twitter:site" content="@Code" /><link rel="canonical" href="https://marketplace.visualstudio.com/items?itemName=ms-azuretools.vscode-azureappservice" />
<meta http-equiv="X-UA-Compatible" content="IE=11;&#32;IE=10;&#32;IE=9;&#32;IE=8" />
    <link rel="SHORTCUT ICON" href="/favicon.ico" />

    
    <link data-bundlelength="197152" data-bundlename="commoncss" data-highcontrast="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/HighContrast/vss-bundle-commoncss-v_uStAD6OSdYf00IrYxAi8DKgxXhyA-JUsVpTyqTRZsc=" data-includedstyles="Gallery3rdParty;Gallery;fabric" href="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/Default/vss-bundle-commoncss-vczttIUQJMWiFXVn33Og_imQ_Xv7xDeb-6tlDj4ZFNx8=" rel="stylesheet" />
<link data-bundlelength="163129" data-bundlename="viewcss" data-highcontrast="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/HighContrast/vss-bundle-viewcss-vhYzzLFyP5GtFj9jiNTD-PTYHCNlOoS5_QIg3hbyjxPE=" data-includedstyles="jQueryUI-Modified;QnA/AskQuestionDialog;Shared/ReadMoreText;Shared/LinkAsButton;QnA/ReadMoreContent;QnA/QnAContainer;QnA/AnswerContent;Shared/FlagControl;QnA/QnAItemRow;ItemDetails/QnAAndRnRContainer;ItemDetails/ItemDetailsMarkdown;Shared/Carousel;ItemDetails/ScreenshotsCarousel;ItemDetails/MetadataListContainer;ItemDetails/CapabilitiesContainer;ItemDetails/ResourcesContainer;ItemDetails/MoreInfoContainer;ItemDetails/GithubDetails;ItemDetails/ItemDetails;Acquisition/Steps/BuyCustomizationEditControl;ItemDetails/NewPricingCalculator;RnR/ReviewReply;RnR/RnRRow;RnR/ReviewDialog;RnR/RnRContainer;ItemDetails/ItemDetailsTabContainer;ItemDetails/OneClickInstallDialog;Shared/MarketplaceCertifiedBadge;Shared/OptInBar;VSS.Controls" href="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/Default/vss-bundle-viewcss-vkwNhI8ftvKwsBucJmNfHrKOxPHjpEjuOGzmbX7StHlM=" rel="stylesheet" />
<script nonce="HQ/TI9ENYTGcaN+YvjsKrw==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('startLoadBundleOuter-basejs'); }</script>
<script data-bundlelength="125076" data-bundlename="basejs" nonce="HQ/TI9ENYTGcaN+YvjsKrw==" src="https://cdn.vsassets.io/bundles/vss-bundle-basejs-v9GpWWBnsWqhM23ijhK2HfAqLowTXGUqZLDRsBCZbkfY=" type="text/javascript"></script>
<script nonce="HQ/TI9ENYTGcaN+YvjsKrw==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('endLoadBundleOuter-basejs'); }</script>


    
    <!-- JSLL script -->
    
    <script type="text/javascript"  nonce="HQ/TI9ENYTGcaN+YvjsKrw==" >

        
                var haveConsent = false;
        

        var jsll_config = {};
        jsll_config.coreData = {};
        jsll_config.cookiesToCollect = ["_mkto_trk"];

        jsll_config.ix = {};
        if(haveConsent){
          jsll_config.ix.a = true;
          jsll_config.ix.g = true;
          jsll_config.syncMuid = true;
        }
        jsll_config.coreData.appId = "marketplace.visualstudio.com";

        var js_callback = function() {
          window.awa.init(jsll_config);
        };

        var jsll = document.createElement("script");
        jsll.type = "text/javascript";
        jsll.src = "//az725175.vo.msecnd.net/scripts/jsll-4.js";
        document.getElementsByTagName("head")[0].appendChild(jsll);
        jsll.onload = js_callback;
        jsll.onreadystatechange = function() {
          if (this.readyState === "complete") {
            js_callback();
          }
        };
    </script>
    
    <!-- End JSLL script -->

</head>
<body class="platform gallery gallery-page-item-details">    
    
            <div><div id='msccBanner' dir='ltr' data-site-name='marketplace.visualstudio.com' data-mscc-version='0.4.2' data-nver='aspnet-3.1.1' data-sver='0.1.2' class='cc-banner' role='alert' aria-labelledby='msccMessage'><div class='cc-container'><svg class='cc-icon cc-v-center' x='0px' y='0px' viewBox='0 0 44 44' height='30px' fill='none' stroke='currentColor'><circle cx='22' cy='22' r='20' stroke-width='2'></circle><line x1='22' x2='22' y1='18' y2='33' stroke-width='3'></line><line x1='22' x2='22' y1='12' y2='15' stroke-width='3'></line></svg> <span id='msccMessage' class='cc-v-center cc-text' tabindex='0'>This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use.</span> <a href='https://go.microsoft.com/fwlink/?linkid=845480' target='_top' aria-label='Learn more about Microsoft&#39;s Cookie Policy' id='msccLearnMore' class='cc-link cc-v-center cc-float-right' data-mscc-ic='false'>Learn more</a></div></div></div>
    
        <!-- Google Tag Manager -->
        <noscript>
            <iframe src="//www.googletagmanager.com/ns.html?id=GTM-WT9XBK"
                height="0" width="0" style="display: none; visibility: hidden"></iframe>
        </noscript>
        <script type="text/javascript"  nonce="HQ/TI9ENYTGcaN+YvjsKrw==">(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
            new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
            j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
            '//www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
            })(window,document,'script','dataLayer','GTM-WT9XBK');</script>
        <!-- End Google Tag Manager -->
    
    <!-- GreenId -->
    <iframe  style="color:rgb(0,0,0);  float:left; position:absolute; top:-200px; left:-200px; border:0px" src="https://fpt.microsoft.com/tags?session_id=a648d42d-6643-41ea-b116-782115b5c97c" height=100  width=100 aria-hidden="true"></iframe>
    <!-- End GreenId -->
    
    <script type="text/javascript" nonce="HQ/TI9ENYTGcaN+YvjsKrw=="> var __vssPageContext = {"webContext":{"host":{"id":"2663b13f-50e3-a655-a159-22f6f4725fab","name":"TEAM FOUNDATION","uri":"https://marketplace.visualstudio.com/","relativeUri":"/","hostType":"deployment","scheme":"https","authority":"marketplace.visualstudio.com"}},"moduleLoaderConfig":{"baseUrl":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/min/","paths":{"Engagement/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","Charts/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","VSS/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","ContentRendering/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","VSSPreview/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","Gallery/Scripts/Gallery/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","highcharts":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts.v7.2.1","highcharts/highcharts-more":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-more.v7.2.1","highcharts/modules/accessibility":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-accessibility.v7.2.1","highcharts/modules/funnel":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-funnel.v7.2.1","highcharts/modules/heatmap":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-heatmap.v7.2.1"},"map":{"*":{"office-ui-fabric-react/lib":"OfficeFabric"}},"contributionPaths":{"VSS":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/VSS","pathType":"default"},"VSS/Resources":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","pathType":"resource"},"q":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/q","pathType":"default"},"knockout":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/knockout","pathType":"default"},"mousetrap":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/mousetrap","pathType":"default"},"mustache":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/mustache","pathType":"default"},"react":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/react.15.3","pathType":"default"},"react-dom":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/react-dom.15.3","pathType":"default"},"react-transition-group":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/react-transition-group.15.3","pathType":"default"},"jQueryUI":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/jQueryUI","pathType":"default"},"jquery":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/jquery","pathType":"default"},"OfficeFabric":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/OfficeFabric","pathType":"default"},"tslib":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/tslib","pathType":"default"},"@uifabric":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/@uifabric","pathType":"default"},"VSSUI":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/VSSUI","pathType":"default"},"Charts":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/Charts","pathType":"default"},"Charts/Resources":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","pathType":"resource"},"ContentRendering":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/ContentRendering","pathType":"default"},"ContentRendering/Resources":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","pathType":"resource"},"highcharts":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts.v7.2.1","pathType":"thirdParty"},"highcharts/highcharts-more":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-more.v7.2.1","pathType":"thirdParty"},"highcharts/modules/accessibility":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-accessibility.v7.2.1","pathType":"thirdParty"},"highcharts/modules/funnel":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-funnel.v7.2.1","pathType":"thirdParty"},"highcharts/modules/heatmap":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-heatmap.v7.2.1","pathType":"thirdParty"}},"shim":{"jquery":{"deps":[],"exports":"jQuery"}},"waitSeconds":30},"coreReferences":{"stylesheets":[{"url":"/_static/tfs/M165_20200226.19/_cssbundles/Default/vss-bundle-ext-core-css-vgEHbWqZ4eb0vmOdl2cWjkpPtqcsX1GJCq4DnY78oN3s=","highContrastUrl":null,"isCoreStylesheet":true}],"scripts":[{"identifier":"JQuery","url":"https://cdn.vsassets.io/3rdParty/_scripts/jquery-2.2.4.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"JQueryXDomain","url":"https://cdn.vsassets.io/3rdParty/_scripts/jquery.xdomainrequest.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"Promise","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/min/promise.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"GlobalScripts","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/min/global-scripts.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"LoaderFixes","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/pre-loader-shim.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":false},{"identifier":"AMDLoader","url":"https://cdn.vsassets.io/3rdParty/_scripts/require.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"LoaderFixes","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/post-loader-shim.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":false}],"coreScriptsBundle":{"identifier":"CoreBundle","url":"/_public/_Bundling/Content?bundle=vss-bundle-basejs-v9GpWWBnsWqhM23ijhK2HfAqLowTXGUqZLDRsBCZbkfY=","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},"extensionCoreReferences":{"identifier":"CoreBundle","url":"https://cdn.vsassets.io/bundles/vss-bundle-ext-core-vyAIky6p-ZuRPHK7Kca4boLAcs1hYjjgZbWBioqvGUPY=","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true}},"webAccessConfiguration":{"isHosted":true,"paths":{"rootPath":"/","staticContentRootPath":"/","staticContentVersion":"M165_20200226.19","resourcesPath":"https://cdn.vsassets.io/v/M165_20200226.19/_content/","staticRootTfs":"https://cdn.vsassets.io/v/M165_20200226.19/","cdnFallbackStaticRootTfs":"/_static/tfs/M165_20200226.19/","staticRoot3rdParty":"https://cdn.vsassets.io/3rdParty/"},"api":{"webApiVersion":"1","areaPrefix":"_","controllerPrefix":"_"},"mailSettings":{"enabled":false},"registryItems":{}},"microsoftAjaxConfig":{"cultureInfo":{"name":"sv-SE","numberFormat":{"CurrencyDecimalDigits":2,"CurrencyDecimalSeparator":",","IsReadOnly":true,"CurrencyGroupSizes":[3],"NumberGroupSizes":[3],"PercentGroupSizes":[3],"CurrencyGroupSeparator":" ","CurrencySymbol":"kr","NaNSymbol":"¤¤¤","CurrencyNegativePattern":8,"NumberNegativePattern":1,"PercentPositivePattern":0,"PercentNegativePattern":0,"NegativeInfinitySymbol":"-∞","NegativeSign":"-","NumberDecimalDigits":2,"NumberDecimalSeparator":",","NumberGroupSeparator":" ","CurrencyPositivePattern":3,"PositiveInfinitySymbol":"∞","PositiveSign":"+","PercentDecimalDigits":2,"PercentDecimalSeparator":",","PercentGroupSeparator":" ","PercentSymbol":"%","PerMilleSymbol":"‰","NativeDigits":["0","1","2","3","4","5","6","7","8","9"],"DigitSubstitution":1},"dateTimeFormat":{"AMDesignator":"","Calendar":{"MinSupportedDateTime":"0001-01-01T00:00:00","MaxSupportedDateTime":"9999-12-31T23:59:59.9999999","AlgorithmType":1,"CalendarType":1,"Eras":[1],"TwoDigitYearMax":2029,"IsReadOnly":true},"DateSeparator":"-","FirstDayOfWeek":1,"CalendarWeekRule":2,"FullDateTimePattern":"'den 'd MMMM yyyy HH:mm:ss","LongDatePattern":"'den 'd MMMM yyyy","LongTimePattern":"HH:mm:ss","MonthDayPattern":"'den 'd MMMM","PMDesignator":"","RFC1123Pattern":"ddd, dd MMM yyyy HH':'mm':'ss 'GMT'","ShortDatePattern":"yyyy-MM-dd","ShortTimePattern":"HH:mm","SortableDateTimePattern":"yyyy'-'MM'-'dd'T'HH':'mm':'ss","TimeSeparator":":","UniversalSortableDateTimePattern":"yyyy'-'MM'-'dd HH':'mm':'ss'Z'","YearMonthPattern":"MMMM yyyy","AbbreviatedDayNames":["sön","mån","tis","ons","tor","fre","lör"],"ShortestDayNames":["sö","må","ti","on","to","fr","lö"],"DayNames":["söndag","måndag","tisdag","onsdag","torsdag","fredag","lördag"],"AbbreviatedMonthNames":["jan","feb","mar","apr","maj","jun","jul","aug","sep","okt","nov","dec",""],"MonthNames":["januari","februari","mars","april","maj","juni","juli","augusti","september","oktober","november","december",""],"IsReadOnly":true,"NativeCalendarName":"Gregoriansk kalender","AbbreviatedMonthGenitiveNames":["jan","feb","mar","apr","maj","jun","jul","aug","sep","okt","nov","dec",""],"MonthGenitiveNames":["januari","februari","mars","april","maj","juni","juli","augusti","september","oktober","november","december",""]},"numberShortForm":{"QuantitySymbols":["K","M","B"],"NumberGroupSize":1000,"ThousandSymbol":"K"},"eras":null}},"timeZonesConfiguration":{},"featureAvailability":{"featureStates":{"VisualStudio.Services.Contribution.EnableOnPremUnsecureBrowsers":false,"VisualStudio.Service.WebPlatform.ClientErrorReporting":true,"Microsoft.VisualStudio.Services.Gallery.Client.UseCdnAssetUri":false,"VisualStudio.Services.WebAccess.SubresourceIntegrity":false,"VisualStudio.Services.IdentityPicker.ReactProfileCard":true,"Microsoft.VisualStudio.Services.Gallery.PublisherReply":true,"Microsoft.VisualStudio.Services.Gallery.ShowVSItemLink":false,"Microsoft.VisualStudio.Services.Gallery.ShowLargeThumbnailAsBrandingIcon":false,"Microsoft.VisualStudio.Services.Gallery.AllowNewAccountAPI":false,"Microsoft.VisualStudio.Services.Gallery.Publisher360.LogGetStartedCount":true,"Microsoft.VisualStudio.Services.Gallery.ShowQnA":true,"Microsoft.VisualStudio.Services.Gallery.EnableQnABypass":true,"Microsoft.VisualStudio.Services.Gallery.EnableQnABypassForVSTS":true,"Microsoft.VisualStudio.Services.Gallery.PrivacyPage":true,"Microsoft.VisualStudio.Services.Gallery.EnableByolForMarketplace":true,"Microsoft.VisualStudio.Services.Gallery.Publisher360.EnableReportsLinkForVSCode":false,"Microsoft.VisualStudio.Services.Gallery.Publisher360.EnableReportsLinkForVSIde":true,"Microsoft.VisualStudio.Services.Gallery.EnableNewTokenAcquisitionExperience":false,"Microsoft.VisualStudio.Services.Gallery.EnableNewTokenAcquisitionExperienceForOffers":true,"Microsoft.VisualStudio.Services.Gallery.EnableNewTokenAcquisitionExperienceForTestManager":false,"Microsoft.VisualStudio.Services.Gallery.EnablePublisherProfilePage":true,"Microsoft.VisualStudio.Services.Gallery.EnableCertifiedPublisherUIChanges":true,"Microsoft.VisualStudio.Services.Gallery.RatingReview":true,"Microsoft.VisualStudio.Services.Gallery.EnableQueriesBasedOnHiddenFlags":true,"Microsoft.VisualStudio.Services.Gallery.EnableStickyBannerOnDetailsPage":true,"VisualStudio.Services.WebPlatform.UseNewBranding":true}},"appInsightsConfiguration":{"enabled":false,"instrumentationKey":"00000000-0000-0000-0000-000000000000","insightsScriptUrl":null},"diagnostics":{"sessionId":"a648d42d-6643-41ea-b116-782115b5c97c","activityId":"a648d42d-6643-41ea-b116-782115b5c97c","bundlingEnabled":true,"cdnAvailable":true,"cdnEnabled":true,"webPlatformVersion":"M165","serviceVersion":"Dev18.M165.1 (build: AzureDevOps_M165_20200313.1)"},"navigation":{"topMostLevel":"deployment","area":"","currentController":"Gallery","currentAction":"Details","commandName":"Gallery.Details","routeId":"LegacyWebAccessRoute","routeValues":{"controller":"Gallery","action":"Details","serviceHost":"2663b13f-50e3-a655-a159-22f6f4725fab (TEAM FOUNDATION)"}},"globalization":{"explicitTheme":"","theme":"Default","culture":"sv-SE","timezoneOffset":0,"timeZoneId":"UTC"},"serviceInstanceId":"00000029-0000-8888-8000-000000000000","hubsContext":{},"serviceLocations":{"locations":{"951917ac-a960-4999-8464-e3f0aa25b381":{"Application":"https://app.vssps.visualstudio.com/","Deployment":"https://app.vssps.visualstudio.com/"}}}};</script><script type="text/javascript" nonce="HQ/TI9ENYTGcaN+YvjsKrw=="> var __cultureInfo = __vssPageContext.microsoftAjaxConfig.cultureInfo;</script>
<script type="text/javascript" nonce="HQ/TI9ENYTGcaN+YvjsKrw=="> (function(){
var unloadStarted = false;
function onRequireError(e) {
    var msg = 'There was an error loading a required file. Would you like to reload the page to try to load again?';
    function reload(prompted) {
        document.cookie = 'TFS-CDN=disabled;max-age=28800;path=/;secure';
        document.cookie = 'TFS-CDNTRACE=report-'+prompted+'-'+(e.requireType === 'requirenotloaded' ? 'require' : encodeURIComponent(JSON.stringify(e.requireModules)))+';path=/;secure';
        document.location.reload(true);
    }
    if (!e || !e.requireType || (e.requireType !== 'scripterror' && e.requireType !== 'requirenotloaded')) {
        throw e;
    }
    if (unloadStarted) {
        return;
    }
    if (!window.requiredModulesLoaded) {
        reload(false);
    }
    else if (window.require && require.defined('VSS/Controls/Dialogs')) {
        require(['VSS/Controls/Dialogs'], function(d) {
            d.showMessageDialog(msg, { title: 'Network Error', buttons: [d.MessageDialog.buttons.yes, d.MessageDialog.buttons.no] }).then(function() { reload(true) });
        });
    }
    else {
        if (confirm(msg)) {
            reload(true);
        }
    }
}
window.addEventListener('beforeunload', function() {
    unloadStarted = true;
});
if (window.requirejs) {
    requirejs.onError = onRequireError;
}
else {
    onRequireError({requireType:'requirenotloaded'});
}
})();require.config(__vssPageContext.moduleLoaderConfig);</script>

    <input name="__RequestVerificationToken" type="hidden" value="YTpjdslhcKCCs9_B5L5bqmLNbvbIvZ_zPxJrwLxfXabBd4G25eSs1umqIjEfy6J6aaAKxU2fOhstpRbd5y_taWV9ieY1" /><input name="__RequestVerificationToken2" type="hidden" value="__RequestVerificationToken2d06e0001-3451-4d53-bb77-daf0f0519131" />  
    <script nonce="HQ/TI9ENYTGcaN+YvjsKrw==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('startLoadBundleOuter-common'); }</script>
<script data-bundlelength="1136561" data-bundlename="common" data-includedscripts="VSS/Fonts/TextFonts;VSS/Fonts/IconFonts;Gallery/Client/Pages/Common/Base.View;Gallery/Client/Common/Telemetry;Gallery/Client/Controls/ErrorControl/ErrorControl.View;Gallery/Client/Service/VSSGallery/VSSGallery;Gallery/Client/Service/VSGallery/VSGallery;VSS/FeatureAvailability/RestClient;VSS/Error;VSS/Bundling" nonce="HQ/TI9ENYTGcaN+YvjsKrw==" src="https://cdn.vsassets.io/bundles/vss-bundle-common-vKxxTjaOwoqlwBx1Uo3cCU7QYbXF27kVCHD-PknU6hdc=" type="text/javascript"></script>
<script nonce="HQ/TI9ENYTGcaN+YvjsKrw==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('endLoadBundleOuter-common'); }</script>
<script nonce="HQ/TI9ENYTGcaN+YvjsKrw==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('startLoadBundleOuter-view'); }</script>
<script data-bundlelength="1401173" data-bundlename="view" data-includedscripts="Gallery/Client/Pages/VSSItemDetails/VSSItemDetails.View;VSS/Error" nonce="HQ/TI9ENYTGcaN+YvjsKrw==" src="https://cdn.vsassets.io/bundles/vss-bundle-view-vn0xuBmswdedQwh20W6GT6J3ddK_4xRFGLbzQI1XqZxI=" type="text/javascript"></script>
<script nonce="HQ/TI9ENYTGcaN+YvjsKrw==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('endLoadBundleOuter-view'); }</script>

<script type="text/javascript" nonce="HQ/TI9ENYTGcaN+YvjsKrw=="> if (window.performance && window.performance.mark) { window.performance.mark('requireStart'); }
require(["VSS/Fonts/TextFonts","VSS/Fonts/IconFonts","Gallery/Client/Pages/VSSItemDetails/VSSItemDetails.View","Gallery/Client/Pages/Common/Base.View","Gallery/Client/Common/Telemetry","Gallery/Client/Controls/ErrorControl/ErrorControl.View","Gallery/Client/Service/VSSGallery/VSSGallery","Gallery/Client/Service/VSGallery/VSGallery","VSS/FeatureAvailability/RestClient","VSS/Error"], function(){  if (window.performance && window.performance.mark) { window.performance.mark('requireEnd'); } window.requiredModulesLoaded=true;  });
</script>


    
    <a href="#start-of-content" class="skip-main">Skip to content</a>  
    <div class="page-content">
        <div class="header-section">
            
            <div class="uxservices-header" role="banner">
                <div id="ux-header">
                <div class="upperBand">
                    <div class="upperBandContent marketplace-header">
                        <a href="/" title="Marketplace" class="left" >  
                            <div class="marketPlaceLogoLink bowtie-icon bowtie-brand-visualstudio vs-brand-icon menu-item-icon"></div>
                            <div class="visualStudioLogoLink"> Visual Studio  </div>
                            <div id="marketPlaceLogoLink" class="marketPlaceLogoLink">|   Marketplace</div>
                        </a>
                        <div class="right">
                             
                            <div id="signIn">
                                
                                    <a href="https://app.vssps.visualstudio.com/_signin?realm=marketplace.visualstudio.com&amp;reply_to=https%3A%2F%2Fmarketplace.visualstudio.com%2Fitems%3FitemName%3Dms-azuretools.vscode-azureappservice&amp;redirect=1&amp;context=eyJodCI6MywiaGlkIjoiMjY2M2IxM2YtNTBlMy1hNjU1LWExNTktMjJmNmY0NzI1ZmFiIiwicXMiOnt9LCJyciI6IiIsInZoIjoiIiwiY3YiOiIiLCJjcyI6IiJ90&amp;workflowId=marketplace&amp;wt.mc_id=o~msft~marketplace~signIn#ctx=eyJTaWduSW5Db29raWVEb21haW5zIjpbImh0dHBzOi8vbG9naW4ud2luZG93cy5uZXQiLCJodHRwczovL2xvZ2luLm1pY3Jvc29mdG9ubGluZS5jb20iXX01" class="scarabLink" style="float:left;margin-left:23px;padding-top:1px;color:#fff;font-weight:400;">
                                        Sign in
                                    </a>
                                
                            </div>                            
                            <div data-fragmentname="SearchBox" id="Fragment_SearchBox">
                              <div class="SearchBox" role="search">
                                <form id="HeaderSearchForm" name="HeaderSearchForm" method="get">
                                  <input id="HeaderSearchTextBox" aria-label="search" name="query" type="text" maxlength="200" autocomplete="off">
                                  <input id="RefinementId" name="refinement" type="hidden" value="198">
                                  <button class="bowtie-icon bowtie-search header-search-button" id="HeaderSearchButton" value="" type="submit"></button>
                                </form>
                                <a id="search-box" class="bowtie-icon bowtie-search metroSearchButton" tabindex="0" title="Search here" role="button"></a>
                              </div>  
                            </div>
                        </div>
                    </div>
                </div>
            </div>
                
            </div>
            
        </div>
        <div class="skiptarget" id="start-of-content"></div>
        <div id="gallery-content">
            
    <script id="item-details-view-template" type="text/html">
    <div class="item-details-control-root">
        <!-- ko if: !showMinimalView -->
        <div class="breadcrumb" role="navigation">
            <div class="gallery-centered-content">
                <span data-bind="template: { name: 'bread-crumb-template', data: breadCrumbViewModel}"></span>
                <!--ko if: vscodeEditorDownloadLink-->
                <span class="vsCodeDownloadLinkContainer">
                    <span data-bind="text: vscodeIntroText"></span>
                    <a class="vsCodeDownloadLink" data-bind="attr: { href: vscodeEditorDownloadLink, target: '_blank', rel: 'noreferrer noopener', 'aria-label': vscodeDownloadDescription }, text: vscodeEditorDownloadText, click: vsCodeDownloadClick()"></a>
                </span>
                <!--/ko -->
            </div>
        </div>
        <div class="optIn-bar-container">
            <div class="gallery-centered-content react-new-acquisition-container" role="complementary">
                <div data-bind="galleryReactElem: acquisitionExperienceOptInBar"></div>
            </div>
        </div>        
        <!-- /ko -->
        <div class="ux-item-details" role="main">
            <div class="ux-section-banner" id="section-banner" data-bind="style: { 'background-color': brandingColor }">
                <div class="ux-section-core gallery-centered-content">
                    <table role="presentation">
                        <tr>
                            <td class="item-img" data-bind="renderRegisteredTemplate: { templateName: 'new-image-template', data: imageViewModelOption() }"></td>
                            <td class="item-header">
                                <div class="item-header-content"  data-bind="css: brandingTheme">
                                    <h1><span class="ux-item-name" data-bind="text: itemName"></span></h1>
                                    <!-- ko if: isTitleTagPresent() && !isNewAcquisitionExperienceEnabled() -->
                                    <span class="ux-item-titleTag" data-bind="text: titleTag, css: brandingTheme"></span>
                                    <!-- /ko -->
                                    <!-- ko if: $data.showReportsLink -->
                                    <span class="divider"> | </span>
                                    <a class="ux-gallery-item-reports-link" data-bind="attr: { href: $data.reportsLink, target:'_blank'}, style: {color: brandingThemeColor}, click: _publishTelemetryEventDetailsPageReportsClicked">
                                        <i class="bowtie-icon bowtie-file-content"></i>
                                        <span data-bind="text: $data.reportsLinkDisplayName"></span>
                                    </a>
                                    <!-- /ko -->
                                    <!-- ko if: $data.showGalleryItemEditLink -->
                                    <span class="divider"> | </span>
                                    <a class="ux-gallery-item-edit-link" data-bind="attr: { href: $data.galleryItemEditLink, target:'_blank'}, style: {color: brandingThemeColor}">
                                        <i class="bowtie-icon bowtie-edit-outline"></i>
                                        <span data-bind="text: $data.galleryItemEditLinkDisplayName"></span>
                                    </a>
                                    <!-- /ko -->
                                    <!-- ko if: $data.galleryItemLink -->
                                    <span class="ux-gallery-item-preview">
                                        <a data-bind="text: $data.galleryItemLinkDisplayName, attr: { href: $data.galleryItemLink, target:'_blank'}"></a>
                                    </span>
                                    <!-- /ko -->
                                    <div class="ux-item-second-row-wrapper">
                                        <!--ko if: $data.publisherLink -->
                                        <div class="ux-item-publisher">
                                            <h2 role="presentation"><a class="ux-item-publisher-link item-banner-focussable-child-item" data-bind="text: $data.publisherDisplayName, attr: { href: $data.publisherLink, 'aria-label': $data.publisherPageLinkDescription }, style: {color: brandingThemeColor}"></a></h2>
                                        </div>
                                        <!-- /ko -->
                                        <!--ko if: !$data.publisherLink -->
                                        <div class="ux-item-publisher">
                                            <h2 role="presentation"><span class="ux-item-publisher-link" data-bind="text: $data.publisherDisplayName, style: {color: brandingThemeColor}"></span></h2>
                                        </div>
                                        <!-- /ko -->
                                        <!-- ko if: showMarketplaceCertifiedBadge -->
                                        <div class="ux-marketplace-certified-badge">
                                            <div data-bind="galleryReactElem: marketplaceCertifiedBadge"></div>
                                        </div>
                                        <!-- /ko -->
                                        <!-- ko if: !showMinimalView -->
                                        <!-- ko if: showInstalls -->
                                        <span class="divider"> | </span>
                                        <div class="ux-item-rating">
                                            <div class="bowtie-icon bowtie-install"></div>
                                            <!-- ko if: !isGetStartedType -->
                                            <span class="installs-text" data-bind="text: installsText, attr: { title: installsHoverText}"></span>
                                            <!-- /ko -->
                                            <!-- ko if: isGetStartedType -->
                                            <span class="clicks-text" data-bind="text: clicksText"></span>
                                            <!-- /ko -->
                                        </div>
                                        <!-- /ko -->

                                        <!-- ko if: showRatingReview && reviewResultsLoaded() -->
                                        <a href='#review-details' class="ux-item-review-rating-wrapper" data-bind="attr: {'aria-label': $data.ratingsScreenReaderText }">
                                            <span class="ux-item-review-rating" data-bind="attr: { title: bannerAverageRatingText }">
                                                <span class="divider"> | </span>
                                                <span class="ux-item-rating-control" data-bind="template: { name: 'rating-control-page-template', data: avgRatingDetailsOnBanner }"></span>
                                                <span class="ux-item-rating-count"> (<span data-bind="{text: bannerTotalReviewCount }"></span>) </span>
                                            </span>
                                        </a>
                                        <!-- /ko -->
                                        <span class="divider"> | </span>
                                        <span class="item-price-category" data-bind="text: itemPriceCategory"></span>
                                        <div class="ux-vsippartner" data-bind="visible: isVSIPPartner">
                                            <span class="divider"> | </span>
                                            <img class="ux-item-vsippartner" data-bind="attr: { src: vsipPartnerImgPath }" />
                                        </div>
                                        <!-- /ko -->
                                    </div>
                                    <div class="ux-item-shortdesc" data-bind="text: itemDescription"></div>
                                    <!-- ko if: !isUnpublished -->
                                    <div class="ux-item-action">
                                        <!-- ko if: !isVSCode && !isVSExtension && !isVSForMacExtension  -->
                                        <!-- ko if: !showMinimalView -->
                                        <!-- ko if: !isNewAcquisitionExperienceEnabled() -->
                                        <!-- ko if: trialButtonVisible -->
                                        <a class="trial-button-container" data-bind="attr: { 'data-toggle': $data.dataTogggle(trialLink), href: trialLink, target: $data.getTargetTrial(), rel: 'noreferrer noopener' }" tabindex="-1">
                                            <button class="ux-button install" data-bind="text: trialButtonText, click: $data.clickActionButton()"></button>
                                        </a>
                                        <!-- /ko-->
                                        <a class="install-button-container" data-bind="attr: { 'data-toggle': $data.dataTogggle(actionLink), href: actionLink, target: $data.getTargetAction(), rel: 'noreferrer noopener', title: actionButtonTitle }, css: {linkDisabled: actionButtonDisabled}, visible: actionButtonVisible" tabindex="-1">
                                            <button class="ux-button install" data-bind="text: actionButtonText, css: {buttonDisabled: actionButtonDisabled, showDropdown: installForPaidUsersSupported}, click: $data.clickActionButton(), disable: actionButtonDisabled"></button>
                                        </a>
                                        <!-- ko if: installForPaidUsersSupported -->
                                        <span role="button" aria-label="dropdown" aria-haspopup="true" class="action-button-dropdown bowtie-icon bowtie-chevron-down-light" data-bind="click: $data.clickActionButtonDropdownIcon(), onOpenDropdown: $data.clickActionButtonDropdownIcon(), css: brandingTheme" tabindex="0"></span>
                                        <!-- /ko-->
                                        <!-- /ko -->
                                        <!-- ko if: isNewAcquisitionExperienceEnabled() -->
                                        <a class="install-button-container" data-bind="attr:{href: acquisitionLink, target: $data.actionLinkNewTabOpen(), title: acquisitionButtonTitle, rel: 'noreferrer noopener'}" tabindex="-1">
                                            <button class="ux-button install" data-bind="text: acquisitionButtonText, css: {buttonDisabled: acquisitionButtonDisabled}, click: $data.clickActionButton(), disable: acquisitionButtonDisabled"></button>
                                        </a>
                                        <span class="trial-info-container" data-bind="text: $data.helpText, visible: $data.helpTextVisible"/>
                                        <!-- /ko -->
                                        <!-- /ko -->
                                        <!-- ko if : showOfferPlans && !isNewAcquisitionExperienceEnabled()-->
                                        <a href="#plan-details" class="ux-item-meter-pricing-wrapper item-banner-focussable-child-item" data-bind="click: $data.clickPricingBanner()">
                                            <span class="ux-item-meter-start-plan" data-bind="text: startPlanInfoText, style: {color: brandingThemeColor}"></span>
                                        </a>
                                        <!-- /ko -->
                                        <!-- /ko -->
                                        <!-- ko if: isDownloadLinkPresent() -->
                                        <!-- ko if: !showMinimalView -->
                                        <a class="download-button-container" data-bind="attr: { 'data-toggle': $data.dataTogggleDownload(downloadLink), href: downloadLink }, click: startDownload" tabindex="-1">
                                            <button class="ux-button install" data-bind="text: downloadButtonText"></button>
                                        </a>
                                        <!-- /ko -->
                                        <!-- /ko -->
                                        <!-- ko if: isClickLinkPresent() -->
                                        <a class="download-button-container" data-bind="attr: { href: downloadLink }, click: startDownload" tabindex="-1">
                                            <button class="ux-button install" data-bind="text: clickButtonText"></button>
                                        </a>
                                        <!-- /ko -->
                                        <!-- ko if: isVSCode -->
                                            <!--ko if: isOneClickInstallExperienceVisible -->
                                            <div class="one-click-install-container">
                                                <div data-bind="galleryReactElem: installButtonContainer"></div>
                                            </div>
                                            <!-- /ko -->
                                        <!-- ko ifnot: isOneClickInstallExperienceVisible -->
                                            <div class="vscode-copy-command-wrapper" data-bind="renderRegisteredTemplate: { templateName: 'vscode-copy-command-template', data: VSCodeCopyCommandOptions() }">
                                            </div>
                                        <!-- /ko -->
                                        <!-- /ko -->
                                        <!-- ko if : !isNewAcquisitionExperienceEnabled() -->
                                        <span data-bind="html: offersCost, visible: offersCost"></span>
                                        <!-- /ko -->
                                        <!-- ko if: isPreviewStringPresent() && !isNewAcquisitionExperienceEnabled() -->
                                        <span class="ux-item-previewString" data-bind="text: previewString"></span>
                                        <!-- /ko -->
                                    </div>
                                    <!--  /ko -->
                                    <div class="ux-item-free-install" data-bind="visible: !isUnpublished && actionDescriptionHtml, html: actionDescriptionHtml"></div>
                                    <div class="ux-item-offers-cost-text" data-bind="visible: offersCostText, html: offersCostText"></div>
                                    <div class="ux-item-unpublished-text" data-bind="visible: unpublishedText">
                                        <span class="ux-item-unpublished-status-icon bowtie-icon bowtie-status-info"></span>
                                        <span data-bind="text: unpublishedText"></span>
                                    </div>
                                    <!-- /ko -->
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
            <div class="gallery-centered-content">
                <div class="ux-section-details">
                    <div data-bind="galleryReactElem: ItemDetailsComponent"></div>
                </div>
            </div>
            <div class="modal install-page" data-backdrop="static" id="install-pop-up" data-keyboard="true" tabindex="-1" role="dialog" aria-labelledby="item-banner-container">
                <div class="install-page-content gallery-centered-content">
                    <div class="item-banner-container" id="item-banner-container" role="presentation">
                        <div class="install-page-item-banner"></div>
                    </div>
                    <div class="acquire-item-workflow-container"></div>
                </div>
            </div>
        </div>
    </div>
    <!-- ko if: showQnAAndRnRContainer-->
    <div class="gallery-centered-content react-qna-container" id="qna-details" role="complementary" data-bind="attr: {'aria-label': qnaHeadingText}">
       <div data-bind="galleryReactElem: qnaAndRnRContainer"></div>
    </div>
    <!-- /ko -->
</script>
<script id="vscode-copy-command-template" type="text/html">
    <div class="vscode-item-action">
        <!--ko if: isOneClickInstallExperienceVisible -->
        <a class="install-button-container" data-bind="attr: { href: actionLinkInstall}" tabindex="-1">
            <button class="ux-button install" data-bind="text: actionInstallButtonText, click: onVSCodeInstallClick"></button>
        </a>
        <span class="installHelpText">
            <a data-bind="attr: { href: installHelpLink, target: '_blank', rel: 'noreferrer noopener'}, css: brandingTheme, text: installHelpText"></a>
            <i class="bowtie-icon bowtie-navigate-external"></i>
        </span>
        <div class="newExpVSCodeEditorDownload">
            <span data-bind="text: newExpVSCodeEditorInstallText"></span>
            <a class="vsCodeEditorDownloadLink" data-bind="attr: { href: vscodeEditorDownloadLink, target: '_blank', rel: 'noreferrer noopener', 'aria-label': vscodeDownloadDescription }, text: vscodeEditorDownloadText, css: brandingTheme, click: clickCopyCommandDownload()"></a>
            <i class="bowtie-icon bowtie-navigate-external"></i>
        </div>
        <!--<div class="vscode-version">
            <div class="vscode-version-info" data-bind="text: versionSupportedText"></div>
            <a class="vscode-version-info-link" data-bind="attr: { href: versionLink, target: actionLinkNewTab ? '_blank' : '_self' }, text: findVersionText, css: brandingTheme, click: logVersionTelemetry"></a>
        </div>-->
        <!--<div class="vscode-copy">
            <a class="vscode-copy-link" tabindex="0" data-toggle="modal" data-bind="click: function(event) { return openCopyModal() }, enterkey: function(event) { return openCopyModal() }, css: brandingTheme, text: clickHere"></a>
            <div class="vscode-copy-info" data-bind="text: copyInfoText"></div>
        </div>-->
        <!--<div class="vscode-copy-insiders">
            <a class="vscode-insiders-install" data-bind="attr: { href: insidersInstallLink}, text: clickHere, css: brandingTheme, click: logInstallInsidersTelemetry"></a>
            <div class="vscode-insiders-install-info" data-bind="text: insidersInstallInfoText"></div>
        </div>-->
        <!--<div class="modal" id="modal-copy-command-container" tabindex="-1" role="dialog">
            <div class="modal-copy-command">
                <div class="copy-modal-header">
                    <div class="vscode-install-title" data-bind="text: installTitle"></div>
                    <div id="vscode-install-instructions" class="vscode-install-instructions" data-bind="html: installInstructions"></div>
                    <div class="vscode-install-info-container">
                        <div class="vscode-command-container">
                            <input type="text" class="vscode-command-input" readonly="" aria-labelledby="vscode-install-instructions" data-bind="attr: { value: copyCommand, id:textAreaID, size: copyCommandLength }, click: selectTextOnClick"> -->
                            <!-- ko if: iscopySupported || isFlashSupported -->
                            <!--<button class="copy-to-clipboard-button" data-bind="attr: {title: copyButtonTooltip, id: copyButtonID, 'data-clipboard-target': iscopySupported ? null : textAreaID} , click: iscopySupported ? copyOnClick : null, text: copyButtonText, event:{keypress: copyOnEnter}"></button>
                            <div class="copied-result-display" data-bind="text: displayCopyResultText"></div>-->
                            <!-- /ko -->
                        <!--</div>                        
                    </div>
                </div>
                    <div class="copy-modal-footer">
                        <button class="cancel-copy-modal-button" data-dismiss="modal" data-bind="text: cancelButtonText, click: closeCopyModal"></button>
                    </div>
                </div>
        </div>-->
        <!-- /ko -->
        <!--ko ifnot: isOneClickInstallExperienceVisible -->
        <div class="vscode-install-title" data-bind="text: installTitle"></div>
        <div id="vscode-install-instructions" class="vscode-install-instructions" data-bind="html: installInstructions"></div>
        <div class="vscode-install-info-container">
            <div class="vscode-command-container">
                <input type="text" class="vscode-command-input" readonly="" aria-labelledby="vscode-install-instructions" data-bind="attr: { value: copyCommand, id:textAreaID, size: copyCommandLength }, click: selectTextOnClick">
                <!-- ko if: iscopySupported || isFlashSupported -->
                <button class="copy-to-clipboard-button" data-bind="attr: {title: copyButtonTooltip, id: copyButtonID, 'data-clipboard-target': getDataClipBoardtarget()} , click: getCopyClick(), text: copyButtonText, event:{keypress: copyOnEnter}"></button>
                <!-- /ko -->
            </div>
            <div class="copied-display-container">
                <div class="copied-display-div" data-bind="attr: {  id: copiedAnimationID }, text: copiedAnimationText"></div>
            </div>
            <a class="vscode-moreinformation" target="_blank" data-bind="text: actionButtonText, attr: { href: actionLink}, css: brandingTheme, click: publishTelemetryEvent_MoreInfo">
            </a>
        </div>
        <!-- /ko -->
    </div>
</script><script id="image-template" type="text/html">
    <img class="image-display" alt="" data-bind="attr: { src: imageSrc}, css: imageStyle, visible: imageVisible" />
    <div class="bowtie-icon" data-bind="visible: (!imageVisible && !bowtieStyle), css: bowtieStyle "></div>
    <span data-bind="template: { afterRender: componentLoaded($element) }"></span>
</script><script id="carousel-template" type="text/html">
       <div class="carousel-wrapper">    
           <div class="carousel" role="listbox" aria-orientation="horizontal" data-bind='foreach: items, scroll: viewPortStartIndex'>
               <!-- ko if: $parent.showItem($index()) -->
               <div class="carousel-item" data-bind='enterkey: $parent.itemEnterPress(), template: { name: $parent.itemsDisplayTemplate }, attr:{tabindex: $parent.getTabIndexForItem($index())}'></div>
               <!-- /ko -->
           </div>
        </div>
        <div class="carousel-indicators" data-bind="foreach: indicators, event: { keydown: carouselIndicatorKeyHandler }">
            <span class="indicator" role="button" tabindex="0" aria-label="indicator" data-bind="css: { active: $parent.getCss($index()) }, 
                click: $parent.indicatorSelect($index()),
                enterkey: $parent.indicatorSelect($index()),
                spacekey: $parent.indicatorSelect($index())"></span>
        </div>
        <div class="carousel-nav" data-bind="if: ifNav()">
            <a href="" title="next" class="carousel-next gallery-element-focus-style-light" data-bind="click: scrollRight, css: { disabled: caraousalNextDisabled() }"><i class="bowtie-icon bowtie-chevron-right"></i></a>
            <a href="" title="previous" class="carousel-prev gallery-element-focus-style-light" data-bind="click: scrollLeft, css: { disabled: caraousalPrevDisabled() }"><i class="bowtie-icon bowtie-chevron-left"></i></a>
        </div>
</script>
<script id="gallery-item-card-template" type="text/html">
    <a class="gallery-item-card-container" data-bind="attr: { href: link, target: linkTarget, 'aria-label': getScreenReaderText(), tabindex: getTabindex() }, click: itemTileClick()">
        <div class="gallery-item-card" data-bind="attr: { link: itemClassName, title: title}">
            <div class="cover">
                <!-- ko if: showCertifiedBadge -->
                <i class="active-user-info certified-badge-image" data-bind="attr: { title: certifiedBadgeText }, text: certifiedBadgeIcon" />
                <!-- /ko -->
                <div class="icon-cell" data-bind="renderRegisteredTemplate: { templateName: 'new-image-template', data: imageViewModelOption() }, attr: { title: title }"></div>
                <div class="core-info-cell">
                    <div class="name">
                        <span class="item-title" data-bind="text: title" />
                        <!-- TextFadeout based on extension title. MaxWidth of title: 158px and Fadeout width: 30px -->
                        <span class="text-fadeout" data-bind="style: {width: calculateWidthBasedOnSibling($element, 'item-title', 158, '30px')}" />
                    </div>
                    <!--ko ifnot: showInstallCount -->
                    <div class="publisher">
                        <span data-bind="text: publisher, attr: { title: publisher }"> </span>
                    </div>
                    <span class="text-fadeout"></span>
                    <!-- /ko -->
                    <!--ko if: showInstallCount -->
                    <div class="core-info-second-row">
                        <span class="installs" data-bind="visible: installCount !== '0'">
                            <i class="bowtie-icon bowtie-install install-icon" />
                            <span class="install-count" data-bind="text: installCount"></span>
                        </span>
                        <div class="publisher">
                            <span data-bind="text: publisher, attr: { title: publisher }" />
                            <span class="text-fadeout" />
                        </div>
                    </div>
                    <!-- /ko -->
                </div>
            </div>
            <div class="details">
                <div class="description" data-bind="text: description, attr: { title: description }" />
            </div>
            <div class="stats-and-offer">
                <!-- ko if: showRatingReview -->
                <div class="rating-and-price">
                    <div role="img" class="rating" data-bind="template: { name: 'rating-control-page-template', data: ratingViewModel }, attr: { 'alt': averageRatingText, title: averageRatingText }"></div>
                    <div class="pricing-tag" data-bind="text: pricingTag, attr: { title: pricingTag }"></div>
                    <span class="text-fadeout" />
                </div>
                <!-- /ko -->
                <!-- ko ifnot: showRatingReview -->
                <div class="pricing-tag" data-bind="text: pricingTag, attr: { title: pricingTag }"></div>
                <span class="text-fadeout" />
                <!-- /ko -->
            </div>
        </div>
    </a>
</script>
<script id="rating-control-page-template" type="text/html">
    <span class="rating-control">
        <!-- ko foreach: fullStarArray() -->
        <img class="star full-star" alt="" data-bind="event: {click: $parent.fullStarClick($index()),
                                                       mouseover: $parent.fullStarMouseOver($index()), 
                                                       mouseout: $parent.fullStarMouseOut(),
                                                       keypress: $parent.fullStarKeyPress($index())},
                                                       attr: {tabindex: $parent.starTabIndex(), src: $parent.fullStarPath, 'aria-label': $index()+1+' star' }" />
        <!-- /ko -->

        <!-- ko if: isReadOnly-->
        <!-- ko foreach: halfStarArray() -->
        <img class="star half-star" alt="" data-bind="attr: {tabindex: $parent.starTabIndex(), src: $parent.halfStarPath}" />
        <!-- /ko -->
        <!-- /ko -->

        <!-- ko foreach: emptyStarArray() -->
        <img class="star empty-star" alt="" data-bind="event: {click: $parent.emptyStarClick($index()),
                                                        mouseover:$parent.emptyStarMouseOver($index()), 
                                                        keypress: $parent.emptyStarKeyPress($index())},
                                                        attr: {tabindex: $parent.starTabIndex(), src: $parent.emptyStarPath, 'aria-label': $index()+1+$parent.fixedFullStars()+' star'}" />
        <!-- /ko -->
    </span>

</script><script id="item-banner-template" type="text/html">
    <div class="item-banner-root" data-bind="css: itemCss">
        <table class="item-banner" role="presentation">
            <tr>
                <td class="item-header" data-bind="style: { 'background-color': brandingColor }, css: brandingTheme">
                    <div class="item-header-content">
                        <div class="ux-item-name" data-bind="text: title"></div>
                        <div class="ux-item-description" data-bind="text: publisherDisplay"></div>
                    </div>
                </td>
            </tr>
        </table>
    </div>
</script><script id="bread-crumb-template" type="text/html">
    <span class="bread-crumb-container" data-bind="foreach: members, event: { keydown: breadcrumbKeyHandler}">
        <!-- ko if: url -->
        <a class="member" data-bind="text: text, attr: {href: url}"></a>
        <!-- /ko -->
        <!-- ko if: !url -->
        <span class="member" data-bind="text: text"></span>
        <!-- /ko -->  
        <!-- Do not draw seprarator after the last member -->
        <span class="separator" data-bind="if: $index() < $parent.members.length-1">></span>
    </span>
</script>
<script id="error-control-template" type="text/html">
    <div class="gallery-error-control">
        <div class="error-text" data-bind="text: errorText"></div>
        <div class="tips-header" data-bind="text: tipsText"></div>
        <div class="error-diagnosis" data-bind="html: errorDiagnosisHtml"></div>
        <div class="report-issue" data-bind="html: contactUsHtml, visible: isHosted"></div>
    </div>
</script><script id="new-image-template" type="text/html">
    <img class="image-display" alt="" data-bind="attr: { src: imageSrc }, css: imageStyle, visible: imageVisible" />
    <div class="bowtie-icon" data-bind="visible: isBowtieVisible(), css: bowtieStyle"></div>
</script><script id="spinner-template" type="text/html">
    <table class="spinner-control-root">
        <tr>
            <td class="spinner-icon">
                <i class="bowtie-icon bowtie-spinner"></i>
            </td>
            <!-- ko ifnot: $data && $data.toString() === '[object Object]' -->  
            <td class="spinner-message" data-bind="text: $data"></td>
             <!-- /ko -->
        </tr>
    </table>
</script>

<script id="spinner-template-accessible" type="text/html">
    <!-- ko if: showSpinner() -->  
    <table class="spinner-control-root">
        <tr>
            <td class="spinner-icon">
                <i class="bowtie-icon bowtie-spinner"></i>
            </td>
            <!-- ko if: spinnerMessage  -->  
            <td class="spinner-message" data-bind="text: spinnerMessage"></td>
             <!-- /ko -->
        </tr>
    </table>
    <!-- /ko -->
</script>

    <script type="text/javascript"  nonce="HQ/TI9ENYTGcaN+YvjsKrw==" src="https://cdn.vsassets.io/3rdParty/_scripts/bootstrap.min.js"></script>
    
    <div class="main-content item-details-main-content">
        <i class="centered big-spinner bowtie-icon bowtie-spinner"></i>
    </div>
    <div class="vss-item-data">
        <script class="vss-extension" defer="defer" type="application/json">{"publisher":{"publisherId":"52b787f2-79a9-4f32-99b4-393afe3005d3","publisherName":"ms-azuretools","displayName":"Microsoft","flags":"verified"},"extensionId":"42691ca6-18d6-4efe-9e9a-1aabad399d4b","extensionName":"vscode-azureappservice","displayName":"Azure App Service","flags":"validated, public, preview","lastUpdated":"2020-03-24T21:38:08.617Z","publishedDate":"2017-09-19T17:28:18.587Z","releaseDate":"2017-09-19T17:28:18.587Z","shortDescription":"An Azure App Service management extension for Visual Studio Code.","versions":[{"version":"0.16.4","flags":"validated","lastUpdated":"2020-03-24T21:40:25.413Z","files":[{"assetType":"Microsoft.VisualStudio.Code.Manifest","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Code.Manifest"},{"assetType":"Microsoft.VisualStudio.Services.Content.Changelog","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.Content.Changelog"},{"assetType":"Microsoft.VisualStudio.Services.Content.Details","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.Content.Details"},{"assetType":"Microsoft.VisualStudio.Services.Content.License","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.Content.License"},{"assetType":"Microsoft.VisualStudio.Services.Icons.Default","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.Icons.Default"},{"assetType":"Microsoft.VisualStudio.Services.Icons.Small","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.Icons.Small"},{"assetType":"Microsoft.VisualStudio.Services.VsixManifest","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.VsixManifest"},{"assetType":"Microsoft.VisualStudio.Services.VSIXPackage","source":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622/Microsoft.VisualStudio.Services.VSIXPackage"}],"properties":[{"key":"Microsoft.VisualStudio.Services.Branding.Color","value":"#3a3d41"},{"key":"Microsoft.VisualStudio.Services.Branding.Theme","value":"dark"},{"key":"Microsoft.VisualStudio.Services.Links.Getstarted","value":"https://github.com/Microsoft/vscode-azureappservice"},{"key":"Microsoft.VisualStudio.Services.Links.Learn","value":"https://github.com/Microsoft/vscode-azureappservice/blob/master/README.md"},{"key":"Microsoft.VisualStudio.Services.Links.Source","value":"https://github.com/Microsoft/vscode-azureappservice"},{"key":"Microsoft.VisualStudio.Services.Links.GitHub","value":"https://github.com/Microsoft/vscode-azureappservice"},{"key":"Microsoft.VisualStudio.Code.Engine","value":"^1.31.0"},{"key":"Microsoft.VisualStudio.Services.GitHubFlavoredMarkdown","value":"true"},{"key":"Microsoft.VisualStudio.Code.ExtensionDependencies","value":"ms-vscode.azure-account"},{"key":"Microsoft.VisualStudio.Code.ExtensionPack","value":""},{"key":"Microsoft.VisualStudio.Code.LocalizedLanguages","value":""}],"assetUri":"https://ms-azuretools.gallerycdn.vsassets.io/extensions/ms-azuretools/vscode-azureappservice/0.16.4/1585085888622","fallbackAssetUri":"https://ms-azuretools.gallery.vsassets.io/_apis/public/gallery/publisher/ms-azuretools/extension/vscode-azureappservice/0.16.4/assetbyname"}],"categories":["Azure"],"tags":["App Service","Azure","keybindings","multi-root ready"],"statistics":[{"statisticName":"install","value":323550.0},{"statisticName":"averagerating","value":4.230769157409668},{"statisticName":"ratingcount","value":13.0},{"statisticName":"trendingdaily","value":0.021962589358352127},{"statisticName":"trendingmonthly","value":57.157484138989169},{"statisticName":"trendingweekly","value":7.6049332306350275},{"statisticName":"updateCount","value":844501.0},{"statisticName":"weightedRating","value":4.3057411451921039}],"installationTargets":[{"target":"Microsoft.VisualStudio.Code","targetVersion":""}],"deploymentType":0}</script>
    </div>
    <div class="vss-item-token">
        <script class="vss-extension-token" defer="defer" type="application/json">null</script>
    </div>
    <div class="vss-item-offer">
        <script class="vss-extension-offer" defer="defer" type="application/json">null</script>
    </div>
    <div class="vss-item-offer-meter-price-data">
        <script class="vss-extension-offer-meter-price" defer="defer" type="application/json">null</script>
    </div>
    <div class="vss-item-offer-meter-price-details-data">
        <script class="vss-extension-offer-meter-price-currency" defer="defer" type="application/json">null</script>
    </div>
    <div class="vss-item-overview-data">
        <script class="vss-item-overview" defer="defer" type="application/json">"# Azure App Service for Visual Studio Code (Preview)\n\n[![Version](https://vsmarketplacebadge.apphb.com/version/ms-azuretools.vscode-azureappservice.svg)](https://marketplace.visualstudio.com/items?itemName=ms-azuretools.vscode-azureappservice) [![Installs](https://vsmarketplacebadge.apphb.com/installs-short/ms-azuretools.vscode-azureappservice.svg)](https://marketplace.visualstudio.com/items?itemName=ms-azuretools.vscode-azureappservice) [![Build Status](https://dev.azure.com/ms-azuretools/AzCode/_apis/build/status/vscode-azureappservice)](https://dev.azure.com/ms-azuretools/AzCode/_build/latest?definitionId=5)\n\nApp Service is Azure\u0027s fully-managed Platform as a Service (PaaS) that let\u0027s you\ndeploy and scale web, mobile, and API apps. Use the Azure App Service extension\nfor VS Code to quickly create, manage, and deploy your websites.\n\n**Visit the [wiki](https://github.com/Microsoft/vscode-azureappservice/wiki) for more information about Azure App Service and how to use the advanced features of the extension.**\n\n\u003eSign up today for your free Azure account and receive 12 months of free popular services, $200 free credit and 25+ always free services 👉 [Start Free](https://azure.microsoft.com/free/open-source).\n\n## Installation\n\n1. Download and install the [Azure App Service extension](https://marketplace.visualstudio.com/items?itemName=ms-azuretools.vscode-azureappservice) for Visual Studio Code\n    \u003e If you\u0027re interested in deploying single page web apps or progressive web apps (something **without** an express server), install the [Azure Storage extension](https://marketplace.visualstudio.com/items?itemName=ms-azuretools.vscode-azurestorage)\n2. Wait for the extension to finish installing then reload Visual Studio Code when prompted\n3. Once complete, you\u0027ll see an Azure icon in the Activity Bar\n    \u003e If your activity bar is hidden, you won\u0027t be able to access the extension. Show the Activity Bar by clicking View \u003e Appearance \u003e Show Activity Bar\n4. Sign in to your Azure Account by clicking Sign in to Azure…\n    \u003e  If you don\u0027t already have an Azure Account, click \"Create a Free Azure Account\" or you can [try Azure for free](https://code.visualstudio.com/tryappservice/?utm_source=appservice-extension)\n\n## Deploy your first Node.js app to Azure\n\nOnce you are signed in to your Azure account and you have your app open in Visual\nStudio Code, click the deploy button in the Azure App Service explorer - it\u0027s\nthe blue up arrow - to deploy your app.\n\n![Deploy button](https://github.com/Microsoft/vscode-azureappservice/raw/master/resources/deploy-button.png)\n\n\u003e Tip: Be sure that your application is listening on the port provided by the PORT environment variable: `server.listen(process.env.PORT)`\n\n1. Choose **Create New App**\n2. Type a globally unique name for your Web App and press Enter. Valid characters for an app name are \u0027a-z\u0027, \u00270-9\u0027, and \u0027-\u0027\n3. Choose your **Node.js version**, LTS is recommended\n4. Select your current workspace if you have your app open already or browse to the directory containing your application code\n\nClick **Yes** when prompted to update your configuration to run `npm install` on the target server.\n\n![Update build notification](https://github.com/Microsoft/vscode-azureappservice/raw/master/resources/update-build-notification.png)\n\nOnce the deployment starts, you\u0027re prompted to update your workspace so that subsequent deploys from this workspace automatically deploy to the same App Service web app. Choose **Yes** to ensure your changes are deployed to the correct app - you can change this later by editing your workspace settings (in `.vscode/settings.json`).\n\n![Always deploy notification](https://github.com/Microsoft/vscode-azureappservice/raw/master/resources/always-deploy-notification.png)\n\nOnce the deployment completes, click **Browse Website** in the prompt to view your freshly deployed website.\n\n## Stream Your Application Logs\n\n1. In the Azure App Service explorer, expand the app then expand **Logs**\n2. Click on **Connect to Log Steam...**\n\n![Connect to logstream](https://github.com/Microsoft/vscode-azureappservice/raw/master/resources/connect-logstream.png)\n\n3. Choose **Yes** when prompted to enable logging and restart the app\n    \u003e File logging is disabled by default and will automatically be disabled within 24 hours\n4. The Visual Studio Code output window opens with a connection to the log stream\n\n```\nConnecting to log stream...\n2019-01-06T07:36:52  Welcome, you are now connected to log-streaming service.\n2019-01-06 07:37:08.038 INFO  - Starting container for site\n2019-01-06 07:37:33.273 INFO  - Container mahernaexpress_0 for site mahernaexpress initialized successfully.\n```\n\n## Known Issues\n\n* Local Git deployment may fail with large commits\n\n## Contributing\n\nThere are a couple of ways you can contribute to this repo:\n\n* **Ideas, feature requests and bugs**: We are open to all ideas and we want to get rid of bugs! Use the Issues section to either report a new issue, provide your ideas or contribute to existing threads.\n* **Documentation**: Found a typo or strangely worded sentences? Submit a PR!\n* **Code**: Contribute bug fixes, features or design changes:\n  * Clone the repository locally and open in VS Code.\n  * Install [TSLint for Visual Studio Code](https://marketplace.visualstudio.com/items?itemName=eg2.tslint).\n  * Open the terminal (press `` CTRL+` ``) and run `npm install`.\n  * To build, press `F1` and type in `Tasks: Run Build Task`.\n  * Debug: press `F5` to start debugging the extension.\n\n### Legal\n\nBefore we can accept your pull request you will need to sign a **Contribution License Agreement**. All you need to do is to submit a pull request, then the PR will get appropriately labelled (e.g. `cla-required`, `cla-norequired`, `cla-signed`, `cla-already-signed`). If you already signed the agreement we will continue with reviewing the PR, otherwise system will tell you how you can sign the CLA. Once you sign the CLA all future PR\u0027s will be labeled as `cla-signed`.\n\n### Code of Conduct\n\nThis project has adopted the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/). For more information see the [Code of Conduct FAQ](https://opensource.microsoft.com/codeofconduct/faq/) or contact [opencode@microsoft.com](https://github.com/Microsoft/vscode-azureappservice/blob/master/mailto:opencode@microsoft.com) with any additional questions or comments.\n\n## Telemetry\n\nVS Code collects usage data and sends it to Microsoft to help improve our products and services. Read our [privacy statement](https://go.microsoft.com/fwlink/?LinkID=528096\u0026clcid=0x409) to learn more. If you don’t wish to send usage data to Microsoft, you can set the `telemetry.enableTelemetry` setting to `false`. Learn more in our [FAQ](https://code.visualstudio.com/docs/supporting/faq#_how-to-disable-telemetry-reporting).\n\n## License\n\n[MIT](https://github.com/Microsoft/vscode-azureappservice/blob/master/LICENSE.md)\n"</script>
    </div>
    <div class="vss-item-pricing-data">
        <script class="vss-item-pricing" defer="defer" type="application/json">""</script>
    </div>
    <div class="vss-item-properties-container">
        <script class="vss-item-properties" defer="defer" type="application/json">{"Microsoft.VisualStudio.Services.Branding.Color":"#3a3d41","Microsoft.VisualStudio.Services.Branding.Theme":"dark","Microsoft.VisualStudio.Services.Links.Getstarted":"https://github.com/Microsoft/vscode-azureappservice","Microsoft.VisualStudio.Services.Links.Learn":"https://github.com/Microsoft/vscode-azureappservice/blob/master/README.md","Microsoft.VisualStudio.Services.Links.Source":"https://github.com/Microsoft/vscode-azureappservice","Microsoft.VisualStudio.Services.Links.GitHub":"https://github.com/Microsoft/vscode-azureappservice","Microsoft.VisualStudio.Code.Engine":"^1.31.0","Microsoft.VisualStudio.Services.GitHubFlavoredMarkdown":"true","Microsoft.VisualStudio.Code.ExtensionDependencies":"ms-vscode.azure-account","Microsoft.VisualStudio.Code.ExtensionPack":"","Microsoft.VisualStudio.Code.LocalizedLanguages":""}</script>
    </div>
    <div class="is-migrated-container">
        <script class="is-migrated" defer="defer" type="application/json">null</script>
    </div>
    <div class="vss-item-badges-container">
        <script class="vss-item-badges" defer="defer" type="application/json">null</script>
    </div>
    <div class="user-login-url-data">
        <script class="user-login-url" defer="defer" type="application/json">"https://app.vssps.visualstudio.com/_signin?realm=marketplace.visualstudio.com\u0026reply_to=https%3A%2F%2Fmarketplace.visualstudio.com%2Fitems%3FitemName%3Dms-azuretools.vscode-azureappservice\u0026redirect=1\u0026context=eyJodCI6MywiaGlkIjoiMjY2M2IxM2YtNTBlMy1hNjU1LWExNTktMjJmNmY0NzI1ZmFiIiwicXMiOnt9LCJyciI6IiIsInZoIjoiIiwiY3YiOiIiLCJjcyI6IiJ90#ctx=eyJTaWduSW5Db29raWVEb21haW5zIjpbImh0dHBzOi8vbG9naW4ud2luZG93cy5uZXQiLCJodHRwczovL2xvZ2luLm1pY3Jvc29mdG9ubGluZS5jb20iXX01"</script>
    </div>
    <div class="is-connected-server-data">
        <script class="is-connected-server" defer="defer" type="application/json">null</script>
    </div>
    <div class="pinned-user-review-data">
        <script class="pinned-user-review" defer="defer" type="application/json">null</script>
    </div>
    <div class="csp-user">
        <script class="is-csp-user" defer="defer" type="application/json">null</script>
    </div>
    <div class="vss-item-scope-data">
        <script class="vss-item-scope" defer="defer" type="application/json">null</script>
    </div>
    
        <div class="OrgPublisherDisplayNames">
        <script class="org-publisher-display-names" defer="defer" type="application/json">["Microsoft","Microsoft DevLabs"]</script>
        </div>
    
    <div class="CreateNewSubscription">
        <script class="vss-subscription-creation" defer="defer" type="application/json">null</script>
    </div>
    
        <div class="needs-aad-auth-data">
            <script class="needs-aad-auth" defer="defer" type="application/json">false</script>
        </div>
    
    <div class="can-update-extension-data">
        <script class="can-update-extension" defer="defer" type="application/json">null</script>
    </div>
     <div class="has-publisher-role-reader-data">
        <script class="has-publisher-role-reader" defer="defer" type="application/json">false</script>
    </div>
    
        <div class="market-url">
            <script class="gallery-browse-url" defer="defer" type="application/json">"https://visualstudiogallery.msdn.microsoft.com/"</script>
        </div>
    
        <div class="msdn-browse-url">
            <script class="msdn-url" defer="defer" type="application/json">null</script>
        </div>
    

    <div class="vss-install-target-id">
        <script class="vss-target-id" defer="defer" type="application/json">null</script>
    </div>
     <div >
        <script class="vss-install-context" defer="defer" type="application/json">null</script>
    </div>
    
            <div class="general-info">
                <script class="general-info-data" defer="defer" type="application/json">{"galleryUrl":"/","resourcesPath":"https://cdn.vsassets.io/v/M165_20200226.19/_content/","isHosted":true}</script>
            </div>
        </div>
        
        <div id="gallery-footer">
            
<footer>
    
    <div id="ux-footer" class="ltr" role="contentinfo">
    
        <div id="baseFooter">
            <div data-fragmentname="BaseFooterLinks" id="Fragment_BaseFooterLinks" xmlns="http://www.w3.org/1999/xhtml">

                <div class="linkList">
                    <ul class="links horizontal">
                        <!-- EU Cookie Consent: Do not consider user consent on clicking any of the links, by setting data-mscc-ic attribute to false -->
                        <li>
                            <a href="https://www.visualstudio.com/support/support-overview-vs" data-mscc-ic="false">Contact us</a>
                        </li>
                        <li>
                            <a href="https://careers.microsoft.com/" data-mscc-ic="false">Jobs</a>
                        </li>
                        <li>
                            <a href="https://go.microsoft.com/fwlink/?LinkID=264782" data-mscc-ic="false">Privacy</a>
                        </li>
                        <li>
                            <a href="https://aka.ms/vsmarketplace-ToU" data-mscc-ic="false">Terms of use</a>
                        </li>
                        <li>
                            <a href="https://www.microsoft.com/en-us/legal/intellectualproperty/Trademarks/EN-US.aspx" data-mscc-ic="false">Trademarks</a>
                        </li>
                    </ul>
                </div>
            </div>
            <div id="rightBaseFooter">
                &copy; 2020 Microsoft
                <span class="microsoftLogo" title="Microsoft"></span>
            </div>
            <div class="clear"></div>
        </div>
    </div>
</footer>

        </div>
        
    </div>

    
    
    <div id="utils-accessibility-announce-polite" class="visually-hidden" aria-live="polite"></div>
    <div id="utils-accessibility-announce-assertive" class="visually-hidden" aria-live="assertive"></div>
</body>
</html>
